let imageList = generateImageList()





function generateImageList () {
  let randomNumberBecauseFuckYouJSBin = Math.ceil(Math.random() * 10)
  let ret = []

  while (randomNumberBecauseFuckYouJSBin--) {
    let id = performance.now() + Math.random()

    ret.push(`https://api.adorable.io/avatars/285/${id}.png`)
  }

  return ret
}





class BurstPlayer {
  _draw (image) {
    this.ui.ctx.drawImage(image, 0, 0, image.width, image.height)
  }

  _loadImage (url) {
    return new Promise((resolve, reject) => {
      let image = new Image
      let index = this.images.indexOf(url)

      image.onerror = reject
      image.onload = () => {
        this.images[index] = image
        resolve(image)
      }
      image.src = url
    })
  }

  _play () {
    this.currentIndex = this.nextIndex
    this._draw(this.images[this.currentIndex])

    if (this.currentIndex === this.nextIndex) {
      this.pause()
    }
  }

  constructor (images, load = true) {
    this.images = images
    this.ui = {
      canvas: document.querySelector('#FINE'),
      meter: document.querySelector('meter')
    }
    this.ui.ctx = this.ui.canvas.getContext('2d')

    this.scheduler.schedule('updateProgress', () => {
      this.ui.meter.setAttribute('value', this.progress)

      if (this.progress === 1) {
        this.scheduler.unschedule('updateProgress')
      }
    }, this)

    if (load) {
      this.load()
      .then(() => {
        this.play()
      })
      .catch((error) => {
        console.error(error)
      })
    }
  }

  load () {
    return new Promise((resolve, reject) => {
      let promises = []

      this.images.forEach((url) => {
        promises.push(this._loadImage(url))
      })

      Promise.all(promises)
      .then((results) => {
        this.loaded = true
        resolve()
      })
      .catch(reject)
    })
  }

  pause () {
    this.scheduler.pause('play')
  }

  play () {
    if (this.scheduler.tasks['play']) {
      this.scheduler.start('play')

    } else {
      this.scheduler.schedule('play', this._play, this)
    }
  }

  get currentIndex () {
    return this._currentIndex || (this._currentIndex = 0)
  }

  get loaded () {
    return this._loaded || false
  }

  get itemCount () {
    return this.images.length
  }

  get nextIndex () {
    return this._nextIndex = (this.currentIndex >= this.images.length - 1) ? this.currentIndex : (this.currentIndex + 1)
  }

  get progress () {
    let progress = 0

    this.images.forEach((item) => {
      if (item instanceof Image) {
        progress++
      }
    })

    return progress / this.images.length
  }

  get scheduler () {
    return this._scheduler || (this._scheduler = new Scheduler)
  }

  set currentIndex (value) {
    this._currentIndex = value
  }

  set loaded (value) {
    this._loaded = value
  }
}





window.player = new BurstPlayer(imageList)
